SystemOrganization addCategory: #SyncRepo!

Object subclass: #RepositoryToSync
	instanceVariableNames: 'repository sync'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!RepositoryToSync methodsFor: 'operations' stamp: 'hjo 4/27/2012 20:41'!
copyFilesTo: copyTarget

	(self files copyWithoutAll: copyTarget files) do: [:each| |version| 
		version := self repository loadVersionFromFileNamed: each. 
		version isNil
			ifTrue: [Transcript cr; nextPutAll: '#loadVersionFromFileNamed: failed. The argument was '; print: each; flush]
			ifFalse: [copyTarget repository storeVersion: version]
		 ].! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:53'!
files

	^repository allFileNames select: [:each| sync willSyncTheFile: each ].
	"^ sync allPackagesAreToSync
		ifTrue: [ repository allFileNames asSet ]
		ifFalse: [ (repository allFileNames select: [ :each | sync packageNames anySatisfy: [ :str | each beginsWith: str , '-' ] ]) asSet ]"! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:35'!
repository
	^ repository! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:35'!
repository: aMCRepository
	repository := aMCRepository
! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:39'!
sync
	^ sync! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:39'!
sync: aSyncRepo
	sync := aSyncRepo
! !

Object subclass: #SyncRepo
	instanceVariableNames: 'packageNames repos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/27/2012 22:56'!
repository: repo1 repository: repo2 

	^self new 
		addRepository: repo1;
		addRepository: repo2;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/27/2012 22:57'!
repository: repo1 repository: repo2 packageNames: anArray

	^self new 
		addRepository: repo1;
		addRepository: repo2;
		packageNames: anArray;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/27/2012 22:57'!
repository: repo1 repository: repo2 stringOfPackageNames: aString

	^self new 
		addRepository: repo1;
		addRepository: repo2;
		packageNames: aString subStrings;
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/21/2012 03:53'!
shareAll

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade2'))! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/25/2012 21:44'!
shareAni

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCHttpRepository location: 'http://www.squeaksource.com/DaliotsPlayground' user: '' password: '') 
		stringOfPackageNames: 'LazyRabbit LazyRabbitOmniBrowser Daliot SortDescriptors Ani ConfigurationOfDaliotsPlayground'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 6/1/2012 12:59'!
shareDevPacer

	^self new 
		addRepository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) ;
		addRepository:  (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/DevPacer'));
		addRepository:  (MCHttpRepository location: 'http://www.squeaksource.com/DaliotsPlayground' user: '' password: '');
		packageNames: 'Ani AniOmniBrowser Daliot LazyRabbit LazyRabbitOmniBrowser DevPacerCommon DevPacerPharo12 DevPacerPharo13 DevPacerPharo14 SortDescriptors' subStrings;
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/21/2012 02:50'!
shareMe

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCHttpRepository location: 'http://ss3.gemstone.com/ss/SyncRepo' user: 'hjo' password: '') stringOfPackageNames: 'SyncRepo'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/23/2012 00:03'!
shareSourceCodeTourGuide

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/SourceCodeTourGuide')) stringOfPackageNames: 
		'Ani Daliot DrillDownMethodSearch LazyRabbit SortDescriptors SourceCodeTourGuide SourceCodeTourGuideOmniBrowser SourceCodeTourGuidePharo12 SourceCodeTourGuidePharo13 SourceCodeTourGuidePharo14'.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/27/2012 22:58'!
addRepository: anMCRepository

	repos add: (RepositoryToSync new  repository: anMCRepository; sync: self).! !

!SyncRepo methodsFor: 'initialize-release' stamp: 'hjo 4/27/2012 22:58'!
initialize

	super initialize.
	repos := OrderedCollection new.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:36'!
packageNames

	^packageNames! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:56'!
packageNames: strings

	packageNames := strings.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/27/2012 23:01'!
stringOfPackageNames: aString

	packageNames := aString subStrings.! !

!SyncRepo methodsFor: 'operation' stamp: 'hjo 4/27/2012 23:07'!
syncRepos

	| tape source target c |
	tape := (repos copyWithoutLast, repos reverse) readStream.
	target := tape next.
	
	[tape atEnd] whileFalse: [
		source := target.
		target := tape next.
		source copyFilesTo: target.
	].! !

!SyncRepo methodsFor: 'testing' stamp: 'hjo 4/27/2012 21:01'!
willSyncTheFile: aString

	packageNames isNil ifTrue: [^true].
	packageNames isEmpty ifTrue: [^true].
	^packageNames anySatisfy: [:each| aString beginsWith: each , '-' ] .! !
